#ifndef __KEYCODE_H__
#define __KEYCODE_H__

enum {
    KEYCODE_NULL      = 0x00,
    KEYCODE_ESC       = 0x01,
    KEYCODE_1         = 0x02,
    KEYCODE_2         = 0x03,
    KEYCODE_3         = 0x04,
    KEYCODE_4         = 0x05,
    KEYCODE_5         = 0x06,
    KEYCODE_6         = 0x07,
    KEYCODE_7         = 0x08,
    KEYCODE_8         = 0x09,
    KEYCODE_9         = 0x0A,
    KEYCODE_0         = 0x0B,
    KEYCODE_MINUS     = 0x0C,
    KEYCODE_HAT       = 0x0D,
    KEYCODE_BS        = 0x0E,
    KEYCODE_TAB       = 0x0F,
    KEYCODE_Q         = 0x10,
    KEYCODE_W         = 0x11,
    KEYCODE_E         = 0x12,
    KEYCODE_R         = 0x13,
    KEYCODE_T         = 0x14,
    KEYCODE_Y         = 0x15,
    KEYCODE_U         = 0x16,
    KEYCODE_I         = 0x17,
    KEYCODE_O         = 0x18,
    KEYCODE_P         = 0x19,
    KEYCODE_ATMARK    = 0x1A,
    KEYCODE_LBRACKET  = 0x1B,
    KEYCODE_ENTER     = 0x1C,
    KEYCODE_LCTRL     = 0x1D,
    KEYCODE_A         = 0x1E,
    KEYCODE_S         = 0x1F,
    KEYCODE_D         = 0x20,
    KEYCODE_F         = 0x21,
    KEYCODE_G         = 0x22,
    KEYCODE_H         = 0x23,
    KEYCODE_J         = 0x24,
    KEYCODE_K         = 0x25,
    KEYCODE_L         = 0x26,
    KEYCODE_SEMICOLON = 0x27,
    KEYCODE_COLON     = 0x28,
    KEYCODE_JP_ZENHAN = 0x29,
    KEYCODE_LSHIFT    = 0x2A,
    KEYCODE_RBRACKET  = 0x2B,
    KEYCODE_Z         = 0x2C,
    KEYCODE_X         = 0x2D,
    KEYCODE_C         = 0x2E,
    KEYCODE_V         = 0x2F,
    KEYCODE_B         = 0x30,
    KEYCODE_N         = 0x31,
    KEYCODE_M         = 0x32,
    KEYCODE_COMMA     = 0x33,
    KEYCODE_PERIOD    = 0x34,
    KEYCODE_SLASH     = 0x35,
    KEYCODE_RSHIFT    = 0x36,
    KEYCODE_NUM_STAR  = 0x37,
    KEYCODE_LALT      = 0x38,
    KEYCODE_SPACE     = 0x39,
    KEYCODE_CAPSLOCK  = 0x3A,
    KEYCODE_F1        = 0x3B,
    KEYCODE_F2        = 0x3C,
    KEYCODE_F3        = 0x3D,
    KEYCODE_F4        = 0x3E,
    KEYCODE_F5        = 0x3F,
    KEYCODE_F6        = 0x40,
    KEYCODE_F7        = 0x41,
    KEYCODE_F8        = 0x42,
    KEYCODE_F9        = 0x43,
    KEYCODE_F10       = 0x44,
    KEYCODE_NUMLOCK   = 0x45,
    KEYCODE_SCROLLLOCK= 0x46,
    KEYCODE_NUM_7     = 0x47,
    KEYCODE_NUM_8     = 0x48,
    KEYCODE_NUM_9     = 0x49,
    KEYCODE_NUM_MINUS = 0x4A,
    KEYCODE_NUM_4     = 0x4B,
    KEYCODE_NUM_5     = 0x4C,
    KEYCODE_NUM_6     = 0x4D,
    KEYCODE_NUM_PLUS  = 0x4E,
    KEYCODE_NUM_1     = 0x4F,
    KEYCODE_NUM_2     = 0x50,
    KEYCODE_NUM_3     = 0x51,
    KEYCODE_NUM_0     = 0x52,
    KEYCODE_NUM_PERIOD= 0x53,
    KEYCODE_SYSREQ    = 0x54,
    KEYCODE_F11       = 0x55,
    KEYCODE_F12       = 0x56,
    KEYCODE_JP_HIRA   = 0x57,
    KEYCODE_UNDERLINE = 0x58,
    KEYCODE_JP_HENKAN = 0x59,
    KEYCODE_JP_MUHEN  = 0x5A,
    KEYCODE_BACKSLASH = 0x5B,
    KEYCODE_NUM_ENTER = 0x5C,
    KEYCODE_RCTRL     = 0x5D,
    KEYCODE_NUM_SLASH = 0x5E,
    KEYCODE_PRTSCREEN = 0x5F,
    KEYCODE_RALT      = 0x60,
    KEYCODE_BREAK     = 0x61,
    KEYCODE_HOME      = 0x62,
    KEYCODE_UP        = 0x63,
    KEYCODE_PAGEUP    = 0x64,
    KEYCODE_LEFT      = 0x65,
    KEYCODE_RIGHT     = 0x66,
    KEYCODE_END       = 0x67,
    KEYCODE_DOWN      = 0x68,
    KEYCODE_PAGEDOWN  = 0x69,
    KEYCODE_INSERT    = 0x6A,
    KEYCODE_DELETE    = 0x6B,
    KEYCODE_LWINDOWS  = 0x6C,
    KEYCODE_RWINDOWS  = 0x6D,
    KEYCODE_MENU      = 0x6E,
    KEYCODE_PAUSE     = 0x6F,
};

#endif /* __KEYCODE_H__ */

